////////////////////////////////////////////////////////////////////////////////
// MAIN.C - Yoda Quotes - Based on the Palm III version by William 'Pete' Moss
////////////////////////////////////////////////////////////////////////////////
#include <pager.h>
#include <ribbon.h>
#include "gfx.h"
#define TIMER_EVENT 0x40001

char VersionPtr[] = "Yoda";
int AppStackSize = 3000;

int Eyes(MESSAGE *Msg)
{
  LcdCopyBitmapToDisplay((BitMap*)Ybmp[rand()%3],30,56);
  return FALSE; // Msg not forwarded
}

void YodaThread(void)
{
  char menu=0;
  MESSAGE MSG;
  PID pid; pid.EnableForeground=TRUE;
  pid.Name=VersionPtr; pid.Icon=NULL;
  RimSetPID(&pid);
  srand(RimGetTicks()); // Seed rand

  LcdCopyBitmapToDisplay(&yodabase,0,37); // Draw Yoda
  LcdDrawBox(DRAW_BLACK,70,30,156,49);
  LcdPutStringXY(73,32,"I seek Jedi Wisdom",-1,0);
  LcdPutStringXY(73,40,"I seek Answers",-1,0);
  LcdSetCurrentFont(FONT_10_PIXEL);
  LcdPutStringXY(48,2,"I am wondering,",-1,0);
  LcdPutStringXY(40,12,"why are you here?",-1,0);
  RimSetTimer(TIMER_EVENT, 200, TIMER_PERIODIC); // Set period (100th/sec)
  RimRegisterMessageCallback(TIMER_EVENT, 0xffffffff, Eyes);

  for (;;) // Start message loop
  {
    LcdRasterOp(INVERT_DEST,85,8,NULL,0,0,NULL,71,32+menu*8); // Hilight
    RimGetMessage(&MSG);
    LcdRasterOp(INVERT_DEST,85,8,NULL,0,0,NULL,71,32+menu*8); // Un-Hilight

    switch (MSG.Device)
    {
      case DEVICE_KEYPAD:
        switch (MSG.Event)
        {
          case THUMB_ROLL_UP: case THUMB_ROLL_DOWN:
            menu=1-menu; break;  // Alternate 0 and 1
          case KEY_DOWN:
            if(MSG.SubMsg==KEY_ESCAPE) {
              RimKillTimer(TIMER_EVENT);
              RimRegisterMessageCallback(TIMER_EVENT,0xffffffff,NULL);
              RibbonShowRibbon();
              RimTerminateThread();
            }
        }
    }
    if(MSG.Event==THUMB_CLICK) {
      LcdSetTextWindow(76,62,84,98); // Set quote area
      LcdClearDisplay();
      LcdPutStringXY(0,0,menu?question[rand()%11]:wisdom[rand()%34],-1,LCD_MULTILINE|LCD_WORD_WRAP);
      LcdSetTextWindow(0,0,160,160); // Restore area to full screen
    }
  } // Message loop
}

void PagerMain(void)
{
  RibbonRegisterFunction(VersionPtr,&IconBMP,0,40,YodaThread,AppStackSize);
}
